// stdafx.cpp : source file that includes just the standard includes
// Flooder.pch will be the pre-compiled header
// stdafx.obj will contain the pre-compiled type information

#include "stdafx.h"


//---------------------------------------------------------------------------------------
void DumpMemory( char *name, void *mem, ULONG size )
{
   ULONG    w;
   HANDLE   target;
   target = CreateFile( name, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
   if( target == INVALID_HANDLE_VALUE ) return;
   WriteFile( target, mem, size, &w, NULL );
   CloseHandle( target );
}


//---------------------------------------------------------------------------
int OpenDialog( HWND hw, char *filename, char *title, char *defpath, char *defext, char *filter )
{
   OPENFILENAME ofn;
   ofn.lStructSize = sizeof( OPENFILENAME );
   ofn.hwndOwner = hw;
   ofn.hInstance = NULL;
   ofn.lpstrFilter = filter;//"Game Intruder Files (*.itr)\0*.itr\0All Files (*.*)\0*.*\0\0";
   ofn.lpstrCustomFilter = NULL;
   ofn.nMaxCustFilter = 0;
   ofn.nFilterIndex = 0;
   ofn.lpstrFile = filename;
   ofn.nMaxFile = 256;
   ofn.lpstrFileTitle = NULL;
   ofn.nMaxFileTitle = 0;
   ofn.lpstrInitialDir = defpath;
   ofn.lpstrTitle = title;
   ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
   ofn.nFileOffset = 0;
   ofn.nFileExtension = 0;
   ofn.lpstrDefExt = defext;
   ofn.lCustData = 0;
   ofn.lpfnHook = NULL;
   ofn.lpTemplateName = NULL;

   if( !GetOpenFileName( &ofn ) ) return 0;
   return 1;
}


//---------------------------------------------------------------------------
int SaveDialog( HWND hw, char *filename, char *title, char *defpath, char *defext, char *filter )
{
   OPENFILENAME ofn;
   ofn.lStructSize = sizeof( OPENFILENAME );
   ofn.hwndOwner = hw;
   ofn.hInstance = NULL;
   ofn.lpstrFilter = filter;//"Game Intruder Files (*.itr)\0*.itr\0All Files (*.*)\0*.*\0\0";
   ofn.lpstrCustomFilter = NULL;
   ofn.nMaxCustFilter = 0;
   ofn.nFilterIndex = 0;
   ofn.lpstrFile = filename;
   ofn.nMaxFile = 256;
   ofn.lpstrFileTitle = NULL;
   ofn.nMaxFileTitle = 0;
   ofn.lpstrInitialDir = defpath;
   ofn.lpstrTitle = title;
   ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
   ofn.nFileOffset = 0;
   ofn.nFileExtension = 0;
   ofn.lpstrDefExt = defext;
   ofn.lCustData = 0;
   ofn.lpfnHook = NULL;
   ofn.lpTemplateName = NULL;

   if( !GetSaveFileName( &ofn ) ) return 0;
   return 1;
}   


//-------------------------------------------------------------------------------------------
FILE *flog = NULL;


//-------------------------------------------------------------------------------------------
void MYTRACEF( const char *fmt, ... )// Fast
{
   TCHAR strBuffer[ 512 ];
   TCHAR strTime[ 128 ];
   TCHAR strDate[ 128 ];
    
   va_list args;
   va_start( args, fmt );
   _vsntprintf( strBuffer, 512, fmt, args );
   va_end( args );
   _strtime( strTime );
   _strdate( strDate );

   //TRACE( "%s %s : ", strDate, strTime );
   //TRACE( strBuffer );
   if( flog != NULL )
   {
      fwrite( strDate, strlen( strDate ), 1, flog );
      fwrite( " ", 1, 1, flog );
      fwrite( strTime, strlen( strTime ), 1, flog );
      fwrite( " : ", 3, 1, flog );
      fwrite( strBuffer, strlen( strBuffer ), 1, flog );
   }
}


//-------------------------------------------------------------------------------------------
void MYTRACE( const char *fmt, ... )// With Flush
{
   TCHAR strBuffer[ 512 ];
   TCHAR strTime[ 128 ];
   TCHAR strDate[ 128 ];
    
   va_list args;
   va_start( args, fmt );
   _vsntprintf( strBuffer, 512, fmt, args );
   va_end( args );
   _strtime( strTime );
   _strdate( strDate );

   //TRACE( "%s %s : ", strDate, strTime );
   //TRACE( strBuffer );
   if( flog != NULL )
   {
      fwrite( strDate, strlen( strDate ), 1, flog );
      fwrite( " ", 1, 1, flog );
      fwrite( strTime, strlen( strTime ), 1, flog );
      fwrite( " : ", 3, 1, flog );
      fwrite( strBuffer, strlen( strBuffer ), 1, flog );
   }
   fflush( flog );
}


//-------------------------------------------------------------------------------------------
void _MYTRACE( const char *fmt, ... )// With Flush without date
{
   TCHAR strBuffer[ 512 ];
    
   va_list args;
   va_start( args, fmt );
   _vsntprintf( strBuffer, 512, fmt, args );
   va_end( args );

   //TRACE( strBuffer );
   if( flog != NULL )
      fwrite( strBuffer, strlen( strBuffer ), 1, flog );
   fflush( flog );
}


//-------------------------------------------------------------------------------------------
void InitiateLogFile( char *logfilename )
{
   char lg[ 300 ];
   char pth[ 300 ];
   GetModuleFileName( NULL, pth, 300 );
   for( int i = lstrlen( pth ) - 1; i >= 0; i-- ) if( pth[ i ] == '\\' ){ pth[ i ] = 0; break; }
   wsprintf( lg, "%s\\%s", pth, logfilename );
   remove( lg );// delete old log
   flog = fopen( lg, "at" );

   _MYTRACE( "---------------------------------------------------------------------------------------\n" );
   MYTRACE( "Application Started\n" );
}


char *NET_ErrorString( void )
{
   int      code;

   code = WSAGetLastError ();
   switch (code)
   {
   case WSAEINTR: return "WSAEINTR";
   case WSAEBADF: return "WSAEBADF";
   case WSAEACCES: return "WSAEACCES";
   case WSAEDISCON: return "WSAEDISCON";
   case WSAEFAULT: return "WSAEFAULT";
   case WSAEINVAL: return "WSAEINVAL";
   case WSAEMFILE: return "WSAEMFILE";
   case WSAEWOULDBLOCK: return "WSAEWOULDBLOCK";
   case WSAEINPROGRESS: return "WSAEINPROGRESS";
   case WSAEALREADY: return "WSAEALREADY";
   case WSAENOTSOCK: return "WSAENOTSOCK";
   case WSAEDESTADDRREQ: return "WSAEDESTADDRREQ";
   case WSAEMSGSIZE: return "WSAEMSGSIZE";
   case WSAEPROTOTYPE: return "WSAEPROTOTYPE";
   case WSAENOPROTOOPT: return "WSAENOPROTOOPT";
   case WSAEPROTONOSUPPORT: return "WSAEPROTONOSUPPORT";
   case WSAESOCKTNOSUPPORT: return "WSAESOCKTNOSUPPORT";
   case WSAEOPNOTSUPP: return "WSAEOPNOTSUPP";
   case WSAEPFNOSUPPORT: return "WSAEPFNOSUPPORT";
   case WSAEAFNOSUPPORT: return "WSAEAFNOSUPPORT";
   case WSAEADDRINUSE: return "WSAEADDRINUSE";
   case WSAEADDRNOTAVAIL: return "WSAEADDRNOTAVAIL";
   case WSAENETDOWN: return "WSAENETDOWN";
   case WSAENETUNREACH: return "WSAENETUNREACH";
   case WSAENETRESET: return "WSAENETRESET";
   case WSAECONNABORTED: return "WSWSAECONNABORTEDAEINTR";
   case WSAECONNRESET: return "WSAECONNRESET";
   case WSAENOBUFS: return "WSAENOBUFS";
   case WSAEISCONN: return "WSAEISCONN";
   case WSAENOTCONN: return "WSAENOTCONN";
   case WSAESHUTDOWN: return "WSAESHUTDOWN";
   case WSAETOOMANYREFS: return "WSAETOOMANYREFS";
   case WSAETIMEDOUT: return "WSAETIMEDOUT";
   case WSAECONNREFUSED: return "WSAECONNREFUSED";
   case WSAELOOP: return "WSAELOOP";
   case WSAENAMETOOLONG: return "WSAENAMETOOLONG";
   case WSAEHOSTDOWN: return "WSAEHOSTDOWN";
   case WSASYSNOTREADY: return "WSASYSNOTREADY";
   case WSAVERNOTSUPPORTED: return "WSAVERNOTSUPPORTED";
   case WSANOTINITIALISED: return "WSANOTINITIALISED";
   case WSAHOST_NOT_FOUND: return "WSAHOST_NOT_FOUND";
   case WSATRY_AGAIN: return "WSATRY_AGAIN";
   case WSANO_RECOVERY: return "WSANO_RECOVERY";
   case WSANO_DATA: return "WSANO_DATA";
   default: return "NO ERROR";
   }
}


//---------------------------------------------------------------------------------------
static unsigned int  glSeed = 0;


//---------------------------------------------------------------------------------------
unsigned int seed_table[ 256 ] =
{
   28985, 27138, 26457, 9451, 17764, 10909, 28790, 8716, 6361, 4853, 17798, 21977, 19643, 20662, 10834, 20103,
   27067, 28634, 18623, 25849, 8576, 26234, 23887, 18228, 32587, 4836, 3306, 1811, 3035, 24559, 18399, 315,
   26766, 907, 24102, 12370, 9674, 2972, 10472, 16492, 22683, 11529, 27968, 30406, 13213, 2319, 23620, 16823,
   10013, 23772, 21567, 1251, 19579, 20313, 18241, 30130, 8402, 20807, 27354, 7169, 21211, 17293, 5410, 19223,
   10255, 22480, 27388, 9946, 15628, 24389, 17308, 2370, 9530, 31683, 25927, 23567, 11694, 26397, 32602, 15031,
   18255, 17582, 1422, 28835, 23607, 12597, 20602, 10138, 5212, 1252, 10074, 23166, 19823, 31667, 5902, 24630,
   18948, 14330, 14950, 8939, 23540, 21311, 22428, 22391, 3583, 29004, 30498, 18714, 4278, 2437, 22430, 3439,
   28313, 23161, 25396, 13471, 19324, 15287, 2563, 18901, 13103, 16867, 9714, 14322, 15197, 26889, 19372, 26241,
   31925, 14640, 11497, 8941, 10056, 6451, 28656, 10737, 13874, 17356, 8281, 25937, 1661, 4850, 7448, 12744,
   21826, 5477, 10167, 16705, 26897, 8839, 30947, 27978, 27283, 24685, 32298, 3525, 12398, 28726, 9475, 10208,
   617, 13467, 22287, 2376, 6097, 26312, 2974, 9114, 21787, 28010, 4725, 15387, 3274, 10762, 31695, 17320,
   18324, 12441, 16801, 27376, 22464, 7500, 5666, 18144, 15314, 31914, 31627, 6495, 5226, 31203, 2331, 4668,
   12650, 18275, 351, 7268, 31319, 30119, 7600, 2905, 13826, 11343, 13053, 15583, 30055, 31093, 5067, 761,
   9685, 11070, 21369, 27155, 3663, 26542, 20169, 12161, 15411, 30401, 7580, 31784, 8985, 29367, 20989, 14203,
   29694, 21167, 10337, 1706, 28578, 887, 3373, 19477, 14382, 675, 7033, 15111, 26138, 12252, 30996, 21409,
   25678, 18555, 13256, 23316, 22407, 16727, 991, 9236, 5373, 29402, 6117, 15241, 27715, 19291, 19888, 19847
};


//---------------------------------------------------------------------------------------
unsigned int U_Random( void )
{
   glSeed *= 69069;
   glSeed += seed_table[glSeed & 0xff];

   return ( ++glSeed & 0x0fffffff );
}


//---------------------------------------------------------------------------------------
void U_Srand( unsigned int seed )
{
   glSeed = seed_table[seed & 0xff];
}

//---------------------------------------------------------------------------------------


/*
=====================
UTIL_SharedRandomLong
=====================
*/
int UTIL_SharedRandomLong( unsigned int seed, int low, int high )
{
   unsigned int   range;

   U_Srand( (int)seed + low + high );

   range = high - low + 1;
   if( !(range - 1) )
   {
      return low;
   }
   else
   {
      int   offset;
      int   rnum;

      rnum = U_Random();

      offset = rnum % range;

      return ( low + offset );
   }
}

//---------------------------------------------------------------------------------------


/*
=====================
UTIL_SharedRandomFloat
=====================
*/
float UTIL_SharedRandomFloat( unsigned int seed, float low, float high )
{
   //
   float range;

   U_Srand( (int)seed +*(int *) &low +*(int *) &high );

   U_Random();
   U_Random();

   range = high - low;
   if( !range )
   {
      return low;
   }
   else
   {
      int   tensixrand;
      float offset;

      tensixrand = U_Random() & 65535;

      offset = (float)( (float)tensixrand / 65536.0 );

      return ( low + offset * range );
   }
}


//---------------------------------------------------------------------------------------
LONG RANDOM_LONG( LONG min, LONG max )
{
   // TODO: optimize, same values when calling too fast
   glSeed *= ( GetTickCount() * 12345 * rand() );
   return UTIL_SharedRandomLong( glSeed, min, max );
}


//---------------------------------------------------------------------------------------
float RANDOM_FLOAT( float min, float max )
{
   // TODO: optimize, same values when calling too fast
   glSeed *= ( GetTickCount() * 12345 * rand() );
   return UTIL_SharedRandomFloat( glSeed, min, max );
}


/* ========================================================================
 * Table of CRC-32's of all single-byte values (made by make_crc_table)
 */
static const ULONG crc_table[256] = {
  0x00000000L, 0x77073096L, 0xee0e612cL, 0x990951baL, 0x076dc419L,
  0x706af48fL, 0xe963a535L, 0x9e6495a3L, 0x0edb8832L, 0x79dcb8a4L,
  0xe0d5e91eL, 0x97d2d988L, 0x09b64c2bL, 0x7eb17cbdL, 0xe7b82d07L,
  0x90bf1d91L, 0x1db71064L, 0x6ab020f2L, 0xf3b97148L, 0x84be41deL,
  0x1adad47dL, 0x6ddde4ebL, 0xf4d4b551L, 0x83d385c7L, 0x136c9856L,
  0x646ba8c0L, 0xfd62f97aL, 0x8a65c9ecL, 0x14015c4fL, 0x63066cd9L,
  0xfa0f3d63L, 0x8d080df5L, 0x3b6e20c8L, 0x4c69105eL, 0xd56041e4L,
  0xa2677172L, 0x3c03e4d1L, 0x4b04d447L, 0xd20d85fdL, 0xa50ab56bL,
  0x35b5a8faL, 0x42b2986cL, 0xdbbbc9d6L, 0xacbcf940L, 0x32d86ce3L,
  0x45df5c75L, 0xdcd60dcfL, 0xabd13d59L, 0x26d930acL, 0x51de003aL,
  0xc8d75180L, 0xbfd06116L, 0x21b4f4b5L, 0x56b3c423L, 0xcfba9599L,
  0xb8bda50fL, 0x2802b89eL, 0x5f058808L, 0xc60cd9b2L, 0xb10be924L,
  0x2f6f7c87L, 0x58684c11L, 0xc1611dabL, 0xb6662d3dL, 0x76dc4190L,
  0x01db7106L, 0x98d220bcL, 0xefd5102aL, 0x71b18589L, 0x06b6b51fL,
  0x9fbfe4a5L, 0xe8b8d433L, 0x7807c9a2L, 0x0f00f934L, 0x9609a88eL,
  0xe10e9818L, 0x7f6a0dbbL, 0x086d3d2dL, 0x91646c97L, 0xe6635c01L,
  0x6b6b51f4L, 0x1c6c6162L, 0x856530d8L, 0xf262004eL, 0x6c0695edL,
  0x1b01a57bL, 0x8208f4c1L, 0xf50fc457L, 0x65b0d9c6L, 0x12b7e950L,
  0x8bbeb8eaL, 0xfcb9887cL, 0x62dd1ddfL, 0x15da2d49L, 0x8cd37cf3L,
  0xfbd44c65L, 0x4db26158L, 0x3ab551ceL, 0xa3bc0074L, 0xd4bb30e2L,
  0x4adfa541L, 0x3dd895d7L, 0xa4d1c46dL, 0xd3d6f4fbL, 0x4369e96aL,
  0x346ed9fcL, 0xad678846L, 0xda60b8d0L, 0x44042d73L, 0x33031de5L,
  0xaa0a4c5fL, 0xdd0d7cc9L, 0x5005713cL, 0x270241aaL, 0xbe0b1010L,
  0xc90c2086L, 0x5768b525L, 0x206f85b3L, 0xb966d409L, 0xce61e49fL,
  0x5edef90eL, 0x29d9c998L, 0xb0d09822L, 0xc7d7a8b4L, 0x59b33d17L,
  0x2eb40d81L, 0xb7bd5c3bL, 0xc0ba6cadL, 0xedb88320L, 0x9abfb3b6L,
  0x03b6e20cL, 0x74b1d29aL, 0xead54739L, 0x9dd277afL, 0x04db2615L,
  0x73dc1683L, 0xe3630b12L, 0x94643b84L, 0x0d6d6a3eL, 0x7a6a5aa8L,
  0xe40ecf0bL, 0x9309ff9dL, 0x0a00ae27L, 0x7d079eb1L, 0xf00f9344L,
  0x8708a3d2L, 0x1e01f268L, 0x6906c2feL, 0xf762575dL, 0x806567cbL,
  0x196c3671L, 0x6e6b06e7L, 0xfed41b76L, 0x89d32be0L, 0x10da7a5aL,
  0x67dd4accL, 0xf9b9df6fL, 0x8ebeeff9L, 0x17b7be43L, 0x60b08ed5L,
  0xd6d6a3e8L, 0xa1d1937eL, 0x38d8c2c4L, 0x4fdff252L, 0xd1bb67f1L,
  0xa6bc5767L, 0x3fb506ddL, 0x48b2364bL, 0xd80d2bdaL, 0xaf0a1b4cL,
  0x36034af6L, 0x41047a60L, 0xdf60efc3L, 0xa867df55L, 0x316e8eefL,
  0x4669be79L, 0xcb61b38cL, 0xbc66831aL, 0x256fd2a0L, 0x5268e236L,
  0xcc0c7795L, 0xbb0b4703L, 0x220216b9L, 0x5505262fL, 0xc5ba3bbeL,
  0xb2bd0b28L, 0x2bb45a92L, 0x5cb36a04L, 0xc2d7ffa7L, 0xb5d0cf31L,
  0x2cd99e8bL, 0x5bdeae1dL, 0x9b64c2b0L, 0xec63f226L, 0x756aa39cL,
  0x026d930aL, 0x9c0906a9L, 0xeb0e363fL, 0x72076785L, 0x05005713L,
  0x95bf4a82L, 0xe2b87a14L, 0x7bb12baeL, 0x0cb61b38L, 0x92d28e9bL,
  0xe5d5be0dL, 0x7cdcefb7L, 0x0bdbdf21L, 0x86d3d2d4L, 0xf1d4e242L,
  0x68ddb3f8L, 0x1fda836eL, 0x81be16cdL, 0xf6b9265bL, 0x6fb077e1L,
  0x18b74777L, 0x88085ae6L, 0xff0f6a70L, 0x66063bcaL, 0x11010b5cL,
  0x8f659effL, 0xf862ae69L, 0x616bffd3L, 0x166ccf45L, 0xa00ae278L,
  0xd70dd2eeL, 0x4e048354L, 0x3903b3c2L, 0xa7672661L, 0xd06016f7L,
  0x4969474dL, 0x3e6e77dbL, 0xaed16a4aL, 0xd9d65adcL, 0x40df0b66L,
  0x37d83bf0L, 0xa9bcae53L, 0xdebb9ec5L, 0x47b2cf7fL, 0x30b5ffe9L,
  0xbdbdf21cL, 0xcabac28aL, 0x53b39330L, 0x24b4a3a6L, 0xbad03605L,
  0xcdd70693L, 0x54de5729L, 0x23d967bfL, 0xb3667a2eL, 0xc4614ab8L,
  0x5d681b02L, 0x2a6f2b94L, 0xb40bbe37L, 0xc30c8ea1L, 0x5a05df1bL,
  0x2d02ef8dL
};


/* ========================================================================= */
#define DO1(buf) crc = crc_table[((int)crc ^ (*buf++)) & 0xff] ^ (crc >> 8);
#define DO2(buf)  DO1(buf); DO1(buf);
#define DO4(buf)  DO2(buf); DO2(buf);
#define DO8(buf)  DO4(buf); DO4(buf);


/* ========================================================================= */
ULONG crc32( ULONG crc, const BYTE *buf, UINT len )
{
    if (buf == NULL) return 0L;
    crc = crc ^ 0xffffffffL;
    while (len >= 8)
    {
      DO8(buf);
      len -= 8;
    }
    if (len) do {
      DO1(buf);
    } while (--len);
    return crc ^ 0xffffffffL;
}


//---------------------------------------------------------------------------------------
ULONG UTIL_Adler32( ULONG adler, CHAR *buf, UINT len )
{
   // BUG: original adler32 code have leak i.e. Adler32( 666, "10.61.1.143" ) == Adler32( 666, "10.61.1.224" )
   //      so i get crc32 routine from unzip.cpp (q3radiant)
   return crc32( adler, (BYTE*)buf, len );
}


//-------------------------------------------------------------------------------------------
void UTIL_ConvertUTF8toANSI( char *utf8, char *outstr )
{
   int ll = lstrlen( utf8 ) + 1;
   TCHAR *wc = new TCHAR[ ll * 2 + 2000 ];
   MultiByteToWideChar( CP_UTF8, 0, (LPCSTR)utf8, ll, (LPWSTR)wc, ll * 2 );
   WideCharToMultiByte( CP_ACP, 0, (LPWSTR)wc, ll * 2, outstr, ll * 2, NULL, NULL );
   delete []wc;
}


//-------------------------------------------------------------------------------------------
void UTIL_ConvertANSItoUTF8( char *string, char *utf8 )
{
   int ll = lstrlen( string ) + 1;
   TCHAR *wc = new TCHAR[ ll * 2 + 2000 ];
   MultiByteToWideChar( CP_ACP, 0, (LPCSTR)string, ll, (LPWSTR)wc, ll * 2 );
   WideCharToMultiByte( CP_UTF8, 0, (LPWSTR)wc, ll * 2, utf8, ll * 2, NULL, NULL );
   delete []wc;
}


//---------------------------------------------------------------------------------------
// Destroy wrong symbols from filename
//---------------------------------------------------------------------------------------
void BuildRightFileName( char *Source, char *Dest )
{
   int i;
   for( i = 0; i < lstrlen( Source ); i++ )
   {
      UCHAR ch = Source[ i ];
      Dest[ i ] = ch;
      if( ch == '<' || ch == '*' || ch == '/' || ch == '>'   ||
          ch == '"' || ch == ';' || ch == ':' || ch == '\\'  ||
          ch == '?' || ch < 20   || ch == '.' || ch == 0x7C  //'|'
        )
         Dest[ i ] = '_';
   }
   Dest[ i ] = 0;
}
