/*
Odigo Flooder Example
Copyright (C) 2003 Alexander Turkovsky aKa gandalf_g@mail.ru

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-------------------------------------------------------------------------------------------
#include "StdAfx.h"
#include "odigoconnection.h"
#include "msn_md5.h"


//-------------------------------------------------------------------------------------------
int COdigoConnection::SendData( BYTE *buff, int len )
{
   // TODO: devide messages great than 2048 by 2kb blocks

   //MYTRACE( "> %s\n", __FUNCTION__ );
   if( sock == NULL ) return 0;
   int snd = send( sock, (char*)buff, len, 0 );
   if( snd != SOCKET_ERROR && snd > 0 )
   {
      ODC_OnSent( buff, len );
#ifdef _DEBUG
      char ts[ 400 ];
      char nam[ 400 ];
      lstrcpy( nam, "00000000" );
      wsprintf( ts, "%i", m_iSendCount );
      lstrcpy( nam + 8 - lstrlen( ts ), ts );
      wsprintf( ts, "%s\\Debug\\Sent\\%s.dat", szExeDir, nam );
      DumpMemory( ts, buff, snd );
#endif
      MYTRACE( "> %s, SendData(%i): %lu bytes\n", __FUNCTION__, m_iSendCount, snd );
      m_iSendCount++;
      m_iSendTraff += snd;
   }else{
      MYTRACE( "> %s, SendData: Failed...\n", __FUNCTION__ );
   }
   return snd;
}


//-------------------------------------------------------------------------------------------
int COdigoConnection::RecvData( BYTE *buff, int maxlen )
{
   //MYTRACE( "> %s\n", __FUNCTION__ );
   if( sock == NULL ) return 0;
   int read = recv( sock, (char*)buff, maxlen, 0 );
   if( read != SOCKET_ERROR && read > 0 )
   {
      ODC_OnReceived( buff, read );
#ifdef _DEBUG
      char ts[ 400 ];
      char nam[ 400 ];
      lstrcpy( nam, "00000000" );
      wsprintf( ts, "%i", m_iRecvCount );
      lstrcpy( nam + 8 - lstrlen( ts ), ts );
      wsprintf( ts, "%s\\Debug\\Recv\\%s.dat", szExeDir, nam );
      DumpMemory( ts, buff, read );
#endif
      MYTRACE( "> %s, RecvData(%i): %lu bytes\n", __FUNCTION__, m_iRecvCount, read );
      m_iRecvCount++;
      m_iRecvTraff += read;
   }else{
      MYTRACE( "> %s, RecvData: Failed...\n", __FUNCTION__ );
   }

   bool readmore = false;

   if( read == 2048 || read == 4096 )
      readmore = true;

   if( !readmore && !_strnicmp( (char*)buff + 1, "FBS", 3 ) )
   {
      // check for continue
      COdigoMessage om;
      om.Init( false );
      om.AddBuff( buff, 20, false );
      om.ToBegin();
      //om.Dump2File( "D:\\data" );
      char FBS[ 5 ];
      om.GetBuffWL( (BYTE*)FBS, false, 4 );// FBS
      if( !lstrcmp( FBS, "FBS" ) != 0 )
      {
         USHORT p1 = om.GetRShort();
         USHORT p2 = om.GetRShort();
         if( read < p1 + p2 )
            readmore = true;
      }
   }

   int rd = 0;
   if( readmore )
   {
      // try to read more
      bool sv = InternalRead;
      InternalRead = true;
      WaitUntilRecv( 2000 );
      rd = RecvData( buff + read, maxlen - read );
      InternalRead = sv;
   }

   return read + rd;
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::EncodePassKey( char *pass, char *key, UCHAR result[ 16 ] )
{
   //MYTRACE( "> %s\n", __FUNCTION__ );
   UCHAR buff[ 100 ];
   UINT bufflen = 19;
   //wsprintf( string, "%c%c%c%c%c%c%c%cr v%c%c%c%c%c%c%c%c", 0x43, 0x55, 0x12, 0x78, 0xFE, 0xC5, 0x3B, 0x12, 0xF1, 0xF3, 0x05, 0x90, 0x86, 0xAC, 0xD3, 0xCC );
   UCHAR ac[] = { 0x43, 0x55, 0x12, 0x78, 0xFE, 0xC5, 0x3B, 0x12, 0x72, 0x20, 0x76, 0xF1, 0xF3, 0x05, 0x90, 0x86, 0xAC, 0xD3, 0xCC };
   memcpy( buff, ac, 19 );
   //printf( "ac = '%s'\n", ac );
   
   DWORD codekey;
   memcpy( &codekey, key, 4 );
   codekey = ~codekey;

   UINT xorfrom = bufflen;
   memcpy( buff + bufflen, pass, lstrlen( pass ) ); bufflen += lstrlen( pass );
   memcpy( buff + bufflen, &codekey, 4 ); bufflen += 4;

   for( UINT i = xorfrom; i < bufflen; i++ ) buff[ i ] ^= 0x52;

   MD5_CTX ctx;
   MD5_Init( &ctx );
   MD5_Update( &ctx, buff, bufflen );
   MD5_Final( result, &ctx );
}


//-------------------------------------------------------------------------------------------
bool COdigoConnection::WaitUntilRecv( DWORD ms )
{
   MYTRACE( "> %s( %lu )\n", __FUNCTION__, ms );
   MSG msg;
   m_bWaitingReceiveEvent = true;
   DWORD endms = GetTickCount() + ms;

   while( m_bWaitingReceiveEvent && GetTickCount() < endms )
   {
      // Process messages from system
      if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
         if( GetMessage( &msg, NULL, 0, 0 ) )
         {
            TranslateMessage( &msg );
            DispatchMessage( &msg );
         }
   }
   return GetTickCount() < endms ? true : false;
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::MakeStdHeader( COdigoMessage *om, DWORD msgid, bool compressed )
{
   om->Init( true );
   om->AddDword( 0x00 );// msg lens
   om->AddDword( msgid );// msg type
   om->AddShort( 0x0000 );
   recv_sessid += 256;
   om->AddShort( recv_sessid );//sessid );
   om->AddBuffWL( (BYTE*)IMNum, lstrlen( (char*)IMNum ), false );
   om->AddBuffWL( (BYTE*)odigo_user_name, lstrlen( odigo_user_name ), true );
   om->AddBuffWL( (BYTE*)odigo_user_host, lstrlen( odigo_user_host ), true );
   om->AddRepeatedBytes( 0x00, 2 );
   om->AddByte( compressed == true ? 0x01 : 0x00 );// is compressed
   om->AddRepeatedBytes( 0x00, 3 );
   om->AddBuffWL( (BYTE*)"EOH", 3, false );
   om->AddShortLenToPos( 0x04, true );
}


//-------------------------------------------------------------------------------------------
bool COdigoConnection::ODC_WindowProc( UINT message, WPARAM wParam, LPARAM lParam )
{
   if( message == WM_TIMER )
   {
      if( wParam == MSG_TIMEOUT_CHECK_TIMERID )
      {
         // check messages for timeout
         CheckMessagesTimeout();
      }

      if( wParam == PONGRESPONSETIMERID )
      {
         ::KillTimer( m_Wnd, PONGRESPONSETIMERID );
         if( m_iPingTimeoutCount++ > MAX_ODIGO_PINGTIMEOUTS )
         {
            // ping time out, disconnect
            MYTRACE( "ERROR: Ping timeout, disconnecting!\n" );
            ODC_Disconnect();
         }
      }
      if( wParam == PONGTIMERID )
      {
         SendPong();
         ::SetTimer( m_Wnd, PONGRESPONSETIMERID, PONGRESPONSE_TIMEOUT, NULL );
      }
      if( wParam == MSGPRESPTIMERID )
      {
         FlushResponseStack();
      }
   }

   if( message == WM_USER + 123 )
   {
      if( WSAGETSELECTEVENT( lParam ) == FD_READ )
      {
         if( !InternalRead )
         {
            int read = RecvData( buff, ODIGO_SENDBUFF_LEN );
            if( read == SOCKET_ERROR ) return true;

            ProcessRecvBuffer( buff, read );

            //MYTRACE( "Event: wp: %Xh, lp: %Xh\n", wParam, lParam );
         }
         if( m_bWaitingReceiveEvent ) m_bWaitingReceiveEvent = false;
      }

      if( WSAGETSELECTEVENT( lParam ) == FD_CLOSE )
      {
         m_bWaitingReceiveEvent = false;
         // disconnect
         ODC_Disconnect();
         return true;
      }
   }

   return false;
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::SendPong( void )
{
   MYTRACE( "> %s\n", __FUNCTION__ );
   COdigoMessage   om;

   //buf: 0000  03 46 42 53 00 44 00 08-00 00 0D 03 01 00 00 05   .FBS.D..........
   //     0010  21 16 49 4D 2D 38 30 31-36 37 34 31 38 31 32 36   !.IM-80167418126
   //     0020  36 39 30 34 34 34 33 33-07 33 37 35 32 34 36 35   69044433.3752465
   //     0030  09 6F 64 69 67 6F 2E 63-6F 6D 00 00 00 00 00 00   .odigo.com......
   //     0040  03 45 4F 48 00 03 00 00-00 FF 00 00               .EOH........ 
   MakeStdHeader( &om, 0x01030D00, false );
   om.AddByte( 0x00 );
   om.AddByte( 0x03 );
   om.AddRepeatedBytes( 0x00, 3 );
   om.AddByte( 0xFF );
   om.AddRepeatedBytes( 0x00, 2 );
   om.AddShortLenToPos( 0x06 );

   int len;
   om.GetMsgBuff( SendBuff, &len );
   SendData( SendBuff, len );
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::ProcessRecvBuffer( BYTE *buff, int bufflen )
{
   MYTRACE( "> %s, buff len = %lu\n", __FUNCTION__, bufflen );

   BYTE newbuff[ ODIGO_SENDBUFF_LEN ];
   COdigoMessage om, omt;
   char           FBS[ 40 ];
   BYTE           tmp[ 5000 ];
   char           key[ 100 ];
   BYTE           FE[ 200 ];
   int            len;

   BYTE sbf12[] = {  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x91, 0xF9, 0x00, 0x00,
                     0x00, 0x08, 0x00, 0x12, 0x00, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x02, 0x3F, 0x01, 0xF6, 0x50,
                     0x00, 0x00, 0x00, 0x06, 0x00, 0x12, 0x00, 0x00, 0x00, 0x2D, 0x00, 0x00, 0x00, 0x03, 0x3F, 0x01,
                     0xF6, 0x50, 0x00, 0x00, 0x00, 0x06, 0x00, 0x12, 0x00, 0x00, 0x00, 0x31, 0x00, 0x00, 0x00, 0x01,
                     0x3F, 0x01, 0xF6, 0x50, 0x00, 0x00, 0x00, 0x01, 0x00, 0x12, 0x00, 0x00, 0x00, 0x32, 0x00, 0x00,
                     0x00, 0x02, 0x3F, 0x01, 0xF6, 0x50, 0x00, 0x00, 0x00, 0x14, 0x00, 0x12, 0x00, 0x00, 0x00, 0x33,
                     0x00, 0x00, 0x00, 0x03, 0x3F, 0x01, 0xF6, 0x50, 0x00, 0x00, 0x00, 0x14, 0x00, 0x12, 0x00, 0x00,
                     0x00, 0x36, 0x00, 0x00, 0x00, 0x06, 0x3F, 0x01, 0xF6, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12,
                     0x00, 0x00, 0x00, 0x37, 0x00, 0x00, 0x00, 0x07, 0x3F, 0x01, 0xF6, 0x50, 0x00, 0x00, 0x00, 0x01,
                     0x00, 0x12, 0x00, 0x00, 0x00, 0x38, 0x00, 0x00, 0x00, 0x08, 0x3F, 0x01, 0xF6, 0x50, 0x00, 0x00,
                     0x00, 0x00 };

   om.Init( false );
   om.AddBuff( buff, bufflen, false );
   om.ToBegin();
   //om.Dump2File( "D:\\data" );
   while( 1 )
   {
      int prevpos = om.GetPos();
      if( prevpos > bufflen ) break;

      om.GetBuffWL( (BYTE*)FBS, false, 4 );// FBS
      if( lstrcmp( FBS, "FBS" ) != 0 ) break;
      USHORT p1 = om.GetRShort();
      USHORT p2 = om.GetRShort();
      om.Skip( 1 );
      DWORD PacketType = om.GetDword();
      om.Skip( 2 );
      sessid = om.GetShort();
      MYTRACE( "Recv PacketType = %Xh\n", PacketType );
      int savpos = om.GetPos();

      om.ToPos( prevpos );
      om.GetBuff( newbuff, p1 + p2, false );


      COdigoMessage nom;
      nom.Init( false );
      nom.AddBuff( newbuff, p1 + p2, false );
      nom.ToBegin();

      nom.Skip( 5 );// hdr
      BYTE bp12 = nom.GetByte();
      USHORT dlen = nom.GetRShort();
      nom.ToPos( bp12 - 8 );

      if( nom.GetByte() )
      {
         //
         // compressed message
         //
         nom.ToPos( bp12 );
         nom.GetBuff( TempBuff, dlen, false );
         //MYTRACE( "dlen=%Xh\n", dlen );
         if( !zlb.Inflate_MemoryToMemory( TempBuff, dlen, TempBuff1, ODIGO_SENDBUFF_LEN ) )
         {
            MYTRACE( "ERROR: Message Decompress Failed!\n" );
            return;
         }   
         nom.ToPos( bp12 );
         nom.AddBuff( TempBuff1, zlb.Total_Out, false );
         //nom.Dump2File( "d:\\dmp" );
      }

      nom.ToBegin();
      om.ToPos( savpos );

      switch( PacketType )
      {
         // friend request

         // users search results

         // room search results

         // Pong from server
         case 0x03030D00:
            ODC_OnSelfPing();
            m_iPingTimeoutCount = 0;
            ::KillTimer( m_Wnd, PONGRESPONSETIMERID );
            break;

         // message confirm
         case 0x03036400:
            PushMsgResponse( false, 0x00, sessid, "", "" );// send confirm (TODO: is any need?)
            MsgConfirm( &nom );
            break;

         // user status notification
         case 0x0503C800:
            UserStatus( &nom );
            PushMsgResponse( false, 0x00, sessid, "", "" );// TODO: check
            break;

         // msg with key (pre-auth msg)
         case 0x03030A00:
            om.GetBuffWL( FE, false, 20 );// FE10930
            om.GetBuffWL( tmp, true );// ggtest
            om.GetBuffWL( tmp, true );// odigo.com
            om.Skip( 14 );
            recv_sessid = om.GetShort();// 0x7B11
            om.Skip( 3 );
            om.GetBuffWL( (BYTE*)key, false );// 58049
            if( lstrlen( key ) > 4 )
               key[ lstrlen( key ) - 1 ] = 0;// erase last sym
            // Send Auth
            SendAuthMessage( FE, key, recv_sessid );
            break;

         // some user enter or out the room

         // room message or private
         case 0x05036400:
            ChatMessage( &nom );
            break;

         // list of room users (after room enter)

         // fail auth
         case 0x04030B00:
            ODC_OnFailedAuthorize();
            break;

         // msg with friends (after auth)
         case 0x03030B00:

            // On Good Authorization
            ::SetTimer( m_Wnd, PONGTIMERID, 50000, NULL );
            ::SetTimer( m_Wnd, MSGPRESPTIMERID, 6000, NULL );
            ::SetTimer( m_Wnd, MSG_TIMEOUT_CHECK_TIMERID, MSG_TIMEOUT_CHECK_TIME, NULL );
            ODC_OnSuccessfulAuthorize();

            nom.ToPos( p1 );
            bool isfr = ( nom.GetByte() == 0x00 ? true : false );
            nom.ToBegin();

            //buff: 0000  03 46 42 53 00 42 01 07-00 00 0B 03 03 00 00 11   .FBS.B..........
            //      0010  7C 15 49 4D 38 32 37 33-33 34 39 30 31 39 31 35   |.IM827334901915
            //      0020  36 31 33 34 34 37 36 06-67 67 74 65 73 74 09 6F   6134476.ggtest.o
            //      0030  64 69 67 6F 2E 63 6F 6D-00 00 00 00 00 00 03 45   digo.com.......E
            //      0040  4F 48 00 07 00 00 11 7C-00 00 00 00 00 00 00 00   OH.....|........
            //      0050  00 02 C3 03 03 DF FE 10-00 03 00 00 1A 3F 03 00   .............?..
            //      0060  15 0C 32 31 36 2E 33 33-2E 34 32 2E 38 39 1A 0B   ..216.33.42.89..
            //      0070  00 00 00 78 00 00 7E 00-05 00 38 01 00 0B 07 46   ...x..~...8....F
            //      0080  72 69 65 6E 64 73 13 00-01 00 28 00 00 23 07 33   riends....(..#.3
            //      0090  37 35 32 34 36 35 09 6F-64 69 67 6F 2E 63 6F 6D   752465.odigo.com
            //      00A0  00 01 02 07 33 37 35 32-34 36 35 00 00 01 2C 00   ....3752465...,.
            //      00B0  00 00 13 01 00 0E 0A 43-6F 2D 57 6F 72 6B 65 72   .......Co-Worker
            //      00C0  73 26 00 00 00 11 01 00-0C 08 42 75 73 69 6E 65   s&........Busine
            //      00D0  73 73 39 00 00 00 0F 01-00 0A 06 46 61 6D 69 6C   ss9........Famil
            //      00E0  79 4C 00 00 00 0F 01 00-0A 06 4F 74 68 65 72 73   yL........Others
            //      00F0  5F 00 00 00 4D 00 2B 06-67 67 74 65 73 74 00 00   _...M.+.ggtest..
            //      0100  00 02 01 00 00 00 2F 44-D0 D6 80 00 00 00 00 00   ....../D........
            //      0110  00 00 00 00 00 00 00 00-05 00 00 00 00 00 01 01   ................
            //      0120  00 1E 00 01 00 1A 01 04-03 11 67 61 6E 64 61 6C   ..........gandal
            //      0130  66 5F 67 40 6D 61 69 6C-2E 72 75 00 00 01 00 02   f_g@mail.ru.....
            //      0140  00 09 00 00 00 00 00 00-00                        .........
            om.GetBuffWL( IMNum, false, 100 );// IM8273349019156134476
            om.GetBuffWL( tmp, false );// ggtest
            om.GetBuffWL( tmp, false );// odigo.com
            om.Skip( 14 );
            recv_sessid = om.GetShort();// 0x7B11

            // read friends and groups
            if( isfr )
               FillFriends( &nom );
            else ODC_OnFailFriendsFill();

            // ------------------------------------------------------------------------------------------------------

            //buf: 0000  03 46 42 53 00 42 00 0F-00 00 4C 03 01 00 00 11   .FBS.B....L.....
            //     0010  7E 15 49 4D 38 32 37 33-33 34 39 30 31 39 31 35   ~.IM827334901915
            //     0020  36 31 33 34 34 37 36 06-67 67 74 65 73 74 09 6F   6134476.ggtest.o
            //     0030  64 69 67 6F 2E 63 6F 6D-00 00 00 00 00 00 03 45   digo.com.......E
            //     0040  4F 48 00 03 00 09 6F 64-69 67 6F 2E 63 6F 6D 00   OH....odigo.com.
            //     0050  30 03 46 42 53 00 42 00-9F 00 00 4B 03 01 00 00   0.FBS.B....K....
            //     0060  11 7F 15 49 4D 38 32 37-33 33 34 39 30 31 39 31   ...IM82733490191
            //     0070  35 36 31 33 34 34 37 36-06 67 67 74 65 73 74 09   56134476.ggtest.
            //     0080  6F 64 69 67 6F 2E 63 6F-6D 00 00 00 00 00 00 03   odigo.com.......
            //     0090  45 4F 48 00 03 00 00 00-00 00 00 01 91 F9 00 00   EOH.............
            //     00A0  00 08 00 12 00 00 00 2C-00 00 00 02 3F 01 F6 50   .......,....?..P
            //     00B0  00 00 00 06 00 12 00 00-00 2D 00 00 00 03 3F 01   .........-....?.
            //     00C0  F6 50 00 00 00 06 00 12-00 00 00 31 00 00 00 01   .P.........1....
            //     00D0  3F 01 F6 50 00 00 00 01-00 12 00 00 00 32 00 00   ?..P.........2..
            //     00E0  00 02 3F 01 F6 50 00 00-00 14 00 12 00 00 00 33   ..?..P.........3
            //     00F0  00 00 00 03 3F 01 F6 50-00 00 00 14 00 12 00 00   ....?..P........
            //     0100  00 36 00 00 00 06 3F 01-F6 50 00 00 00 00 00 12   .6....?..P......
            //     0110  00 00 00 37 00 00 00 07-3F 01 F6 50 00 00 00 01   ...7....?..P....
            //     0120  00 12 00 00 00 38 00 00-00 08 3F 01 F6 50 00 00   .....8....?..P..
            //     0130  00 00
            omt.Init( true );
            omt.AddDword( 0x00 );// msg lens
            omt.AddDword( 0x01034C00 );// msg type
            omt.AddShort( 0x0000 );
            recv_sessid += 512;
            omt.AddShort( recv_sessid );//0x7E11
            omt.AddBuffWL( (BYTE*)IMNum, lstrlen( (char*)IMNum ), false );
            omt.AddBuffWL( (BYTE*)odigo_user_name, lstrlen( odigo_user_name ), true );
            omt.AddBuffWL( (BYTE*)odigo_user_host, lstrlen( odigo_user_host ), true );
            omt.AddRepeatedBytes( 0x00, 6 );
            omt.AddBuffWL( (BYTE*)"EOH", 3, false );
            omt.AddShortLenToPos( 0x04, true );
            omt.AddByte( 0x00 );
            omt.AddShort( 0x0003 );
            omt.AddBuffWL( (BYTE*)odigo_user_host, lstrlen( odigo_user_host ), true );// om.AddBuffWL( (BYTE*)"odigo.com", 9 );
            omt.AddShort( 0x3000 );
            omt.AddShortLenToPos( 0x06 );
            omt.GetMsgBuff( SendBuff, &len );
            SendData( SendBuff, len );

            omt.Init( true );
            MakeStdHeader( &omt, 0x01034B00, false );
            omt.AddByte( 0x00 );
            omt.AddByte( 0x03 );
            omt.AddBuff( sbf12, sizeof( sbf12 ), false );
            omt.AddShortLenToPos( 0x06 );
            omt.GetMsgBuff( SendBuff, &len );
            SendData( SendBuff, len );
            break;

         //case 0x03044B00:
         //   om.GetBuffWL( IMNum, 100 );// IM8273349019156134476
         //   om.GetBuffWL( tmp );// ggtest
         //   om.GetBuffWL( tmp );// odigo.com
         //   om.Skip( 14 );
         //   recv_sessid = om.GetShort();// 0x7B11
         //   break;
      }
      om.ToPos( prevpos + p1 + p2 );
   }
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::SendAuthMessage( BYTE *FE, char *key, USHORT recv_sessid )
{
   //MYTRACE( "> %s\n", __FUNCTION__ );
   COdigoMessage   om;
   //BYTE s5[] = { 
   //  0x03, 0x46, 0x42, 0x53, 0x00, 0x44, 0x00, 0x48, 0x00, 0x00, 0x0B, 0x03, 0x02, 0x00, 0x00, 0x0E,// .FBS.D.H........
   //  0x92, 0x07, 0x46, 0x45, 0x32, 0x35, 0x36, 0x38, 0x34, 0x06, 0x67, 0x67, 0x74, 0x65, 0x73, 0x74,// |.FE10930.ggtest
   //  0x09, 0x6F, 0x64, 0x69, 0x67, 0x6F, 0x2E, 0x63, 0x6F, 0x6D, 0x00, 0x10, 0x89, 0x29, 0x57, 0x4F,// .odigo.com...6.q
   //  0x93, 0xAC, 0x64, 0x90, 0x7F, 0xED, 0xD1, 0xE8, 0xDB, 0x74, 0x7E, 0xF0, 0x00, 0x00, 0x00, 0x00,// .v'........o....
   //  0x03, 0x45, 0x4F, 0x48, 0x00, 0x03, 0x00, 0x00, 0x01, 0x01, 0x01, 0x02, 0xC3, 0x03, 0x02, 0x00,// .EOH............
   //  0x00, 0x00, 0x01, 0x03, 0x00, 0x2C, 0x01, 0x26, 0x57, 0x69, 0x6E, 0x32, 0x30, 0x30, 0x30, 0x20,// .....,.&Win2000 
   //  0x57, 0x6F, 0x72, 0x6B, 0x73, 0x74, 0x61, 0x74, 0x69, 0x6F, 0x6E, 0x20, 0x35, 0x2E, 0x31, 0x20,// Workstation 5.1 
   //  0x53, 0x65, 0x72, 0x76, 0x69, 0x63, 0x65, 0x20, 0x50, 0x61, 0x63, 0x6B, 0x20, 0x31, 0x00, 0x00,// Service Pack 1..
   //  0x00, 0x08, 0x03, 0x60, 0x02, 0xB0, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00 };                      // ...`...0....

   unsigned char code[ 16 ];
   EncodePassKey( odigo_user_pass, key, code );
   USHORT sid = recv_sessid - 256;

   om.Init( true );
   om.AddDword( 0x00 );// msg lens
   om.AddShort( 0x0B00 );
   om.AddDword( 0x00000203 );
   om.AddShort( sid );
   om.AddBuffWL( FE, lstrlen( (char*)FE ), false );
   om.AddBuffWL( (BYTE*)odigo_user_name, lstrlen( odigo_user_name ), true );
   om.AddBuffWL( (BYTE*)odigo_user_host, lstrlen( odigo_user_host ), true );
   om.AddByte( 0x00 );
   om.AddBuffWL( code, 16, false );
   om.AddRepeatedBytes( 0x00, 4 );
   om.AddBuffWL( (BYTE*)"EOH", 3, false );
   om.AddShortLenToPos( 0x04, true );
   om.AddByte( 0x00 );
   om.AddDword( 0x01000003 );
   BYTE bts1[] ={ 0x01, 0x01, 0x02, 0xC3, 0x03, 0x02, 0x00, 0x00, 0x00, 0x01, 0x03, 0x00, 0x2C, 0x01 };
   om.AddBuff( bts1, sizeof( bts1 ), false );
   char *opsys = "Win2000 Workstation 5.1 Service Pack 1";//"Win2003 Server 5.1";//
   om.AddBuffWL( (BYTE*)opsys, lstrlen( opsys ), false );
   BYTE bts2[] ={ 0x00, 0x00, 0x00, 0x08, 0x03, 0x60, 0x02, 0xB0, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00 };
   om.AddBuff( bts2, sizeof( bts2 ), false );
   om.AddShortLenToPos( 0x06 );

   int len;
   om.GetMsgBuff( SendBuff, &len );
   SendData( SendBuff, len );
}



//-------------------------------------------------------------------------------------------
void COdigoConnection::SendConfirmation( USHORT conf, USHORT idd )
{
   MYTRACE( "> %s (sid = %Xh)\n", __FUNCTION__, idd );
   COdigoMessage omt;
   MakeStdHeader( &omt, 0x01031400, false );
   omt.AddByte( 0x00 );
   omt.AddByte( 0x03 );
   omt.AddRepeatedBytes( 0x00, 2 );
   omt.AddByte( 0x01 );
   omt.AddShort( conf );
   omt.AddShort( idd );
   omt.AddRepeatedBytes( 0x00, 3 );
   omt.AddShortLenToPos( 0x06 );
   int len;
   omt.GetMsgBuff( SendBuff, &len );
   SendData( SendBuff, len );
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::ChatMessage( COdigoMessage *om )
{
   MYTRACE( "> %s\n", __FUNCTION__ );
   //char ts[ 200 ];

   char numb[ 500 ];
   char host[ 500 ];
   char name[ 500 ];
   char name1[ 500 ];
   char room[ 500 ];
   BYTE tmp[ 500 ];
   char ftext[ 5000 ];
   ZeroMemory( ftext, 5000 );

// private from gg
//buf: 0000  03 46 42 53 00 44 01 8B-00 00 64 03 05 6E 65 CC   .FBS.D....d..ne.
//     0010  F6 15 49 4D 39 31 34 35-31 35 34 30 31 38 38 32   ..IM914515401882
//     0020  39 30 36 32 34 30 32 08-67 67 5F 74 65 73 74 32   9062402.gg_test2
//     0030  09 6F 64 69 67 6F 2E 63-6F 6D 00 00 00 00 00 00   .odigo.com......
//     0040  03 45 4F 48 00 03 00 00-01 08 67 67 5F 74 65 73   .EOH......gg_tes
//     0050  74 32 09 6F 64 69 67 6F-2E 63 6F 6D 00 23 07 33   t2.odigo.com.#.3
//     0060  37 35 32 34 36 35 09 6F-64 69 67 6F 2E 63 6F 6D   752465.odigo.com
//     0070  01 09 67 61 6E 64 61 6C-66 5F 67 00 00 00 00 6E   ..gandalf_g....n
//     0080  65 CC F4 01 00 03 01 00-14 32 30 30 33 2D 30 37   e........2003-07

// private from raven
//buf: 0000  03 46 42 53 00 44 01 5A-00 00 64 03 05 6E 5E CA   .FBS.D.Z..d..n^.
//     0010  BE 15 49 4D 36 31 31 35-31 38 32 37 37 38 30 33   ..IM611518277803
//     0020  32 31 34 39 39 35 35 08-67 67 5F 74 65 73 74 32   2149955.gg_test2
//     0030  09 6F 64 69 67 6F 2E 63-6F 6D 00 00 00 00 00 00   .odigo.com......
//     0040  03 45 4F 48 00 0E 0B 29-00 00 00 01 00 00 00 00   .EOH...)........
//     0050  00 00 00 01 08 67 67 5F-74 65 73 74 32 09 6F 64   .....gg_test2.od
//     0060  69 67 6F 2E 63 6F 6D 00-21 07 35 31 30 36 36 39   igo.com.!.510669
//     0070  34 09 6F 64 69 67 6F 2E-63 6F 6D 01 07 3D 52 61   4.odigo.com..=Ra
//     0080  56 65 4E 3D 00 00 00 00-6E 5E CA BD 01 00 03 01   VeN=....n^......
//     0090  00 14 32 30 30 33 2D 30-37 2D 32 30 54 31 31 3A   ..2003-07-20T11:


   om->Skip( 5 );// hdr
   BYTE bp = om->GetByte();
   USHORT dlen = om->GetRShort();
   om->Skip( 5 );
   USHORT conf = om->GetShort();
   USHORT idd = om->GetShort();
   om->ToPos( bp );
   BYTE bb = om->GetByte();
   om->ToPos( bp );
   USHORT bp1 = om->GetRShort();
   om->Skip( bp1 - 1 );
   //char ts[ 300 ];
   //wsprintf( ts, "cp=%Xh", om->GetPos() );
   //AfxMessageBox( ts );

   bool privatemsg = false;
   if( om->GetByte() == 0x01 ) privatemsg = true;

   if( privatemsg )
   {
      // private
      om->GetBuffWL( tmp, false );// to name
      om->GetBuffWL( tmp, false );// to host
      om->Skip( 2 );
      om->GetBuffWL( (BYTE*)numb, true );
      om->GetBuffWL( (BYTE*)host, true );
      om->Skip( 1 );
      om->GetBuffWL( (BYTE*)name, true );
      om->Skip( 62 );
      bp1 = om->GetRShort(); if( bp1 > 5000 ) bp1 = 4999;
      om->GetBuff( (BYTE*)ftext, bp1, true );

      // message confirmation
      PushMsgResponse( true, conf, idd, numb, host );
      ODC_OnPrivateMessage( ftext, name, numb, host );
      return;
   }

   om->ToPos( bp );
   om->Skip( 5 );
   // room message
   om->Skip( 2 );

   om->GetBuffWL( (BYTE*)numb, true );
   om->GetBuffWL( (BYTE*)host, true );
   om->Skip( 1 );
   om->GetBuffWL( (BYTE*)name, true );
   om->Skip( 1 );
   om->GetBuffWL( (BYTE*)room, true );
   om->GetBuffWL( (BYTE*)name1, true );
   om->Skip( 10 );
   om->GetBuffWL( tmp, false );
   om->GetBuffWL( tmp, false );
   om->Skip( 7 );
   bp1 = om->GetRShort(); if( bp1 > 5000 ) bp1 = 4999;
   om->GetBuff( (BYTE*)ftext, bp1, true );
   // Silent flag (lame detect)
   om->ToEnd();
   om->Skip( -4 );
   bool silent = false;
   if( om->GetByte() > 0 ) silent = true;

   // convert
   MYTRACE( "ODC_OnRoomMessage( %s, %s, %s, %s, %s )\n", ftext, room, name1, numb, host );
   PushMsgResponse( false, conf, idd, numb, host );
   ODC_OnRoomMessage( ftext, room, name1, numb, host, silent );
}


//-------------------------------------------------------------------------------------------
bool COdigoConnection::ODC_Connect( HWND hwnd )
{
   MYTRACE( "> %s( %Xh )\n", __FUNCTION__, hwnd );
   m_Wnd = hwnd;

   COdigoMessage   om;
   int len;

   // delete debug data
#ifdef _DEBUG
   char mask[ 400 ];
   WIN32_FIND_DATA FindFileData;
   HANDLE hFirstFileHandle;
   MYTRACE( "   Deleting debug files...\n" );

   wsprintf( mask, "%s\\Debug\\Recv\\*.dat", szExeDir );
   // delete any temporary file created
   hFirstFileHandle = FindFirstFile( mask, &FindFileData );
   while( hFirstFileHandle )
   {
      if( !(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && 
           FindFileData.nFileSizeLow >= 0 && lstrlen( FindFileData.cFileName ) < 20 )
      {
         char ff[ MAX_PATH ];
         wsprintf( ff, "%s\\Debug\\Recv\\%s", szExeDir, FindFileData.cFileName );
         //MYTRACE( "   > deleting: %s\n", ff );
         DeleteFile( ff );
      }
      if( !FindNextFile( hFirstFileHandle, &FindFileData ) ) break;
   }

   wsprintf( mask, "%s\\Debug\\Sent\\*.dat", szExeDir );
   // delete any temporary file created
   hFirstFileHandle = FindFirstFile( mask, &FindFileData );
   while( hFirstFileHandle )
   {
      if( !(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && 
           FindFileData.nFileSizeLow >= 0 && lstrlen( FindFileData.cFileName ) < 20 )
      {
         char ff[ MAX_PATH ];
         wsprintf( ff, "%s\\Debug\\Sent\\%s", szExeDir, FindFileData.cFileName );
         //MYTRACE( "   > deleting: %s\n", ff );
         DeleteFile( ff );
      }
      if( !FindNextFile( hFirstFileHandle, &FindFileData ) ) break;
   }

#endif

   InternalRead = true;

   // connect
   MYTRACE( "   Creating socket...\n" );
   sock = socket( AF_INET, SOCK_STREAM, 6 );
   m_iPingTimeoutCount = 0;

   //hostent *hent = gethostbyname( "localhost" );
   sockaddr_in sa;
   ZeroMemory( &sa, sizeof( sa ) );

   if( bIsUseProxy )
   {
      MYTRACE( "   Connecting Using proxy (%s:%i), odigo(%s:%i)...\n", proxy_addr, proxy_port, odigo_addr, odigo_port );
      sa.sin_port = htons((unsigned short)proxy_port);
      sa.sin_family = AF_INET;
      sa.sin_addr.S_un.S_addr = inet_addr( proxy_addr );// "127.0.0.1" -> 0x100007F
      if( connect( sock, (sockaddr*)&sa, sizeof( sockaddr_in ) ) )
      {
         MYTRACE( "   ERROR: Unable connect to Proxy\n" );
         //AfxMessageBox( "Unable to connect" );
   shutshit:;
         shutdown( sock, 2 );
         closesocket( sock );
         return false;
      }

      //InternalRead = true;
      WSAAsyncSelect( sock, hwnd, WM_USER + 123, FD_READ | FD_CLOSE );

      //
      // connect through proxy
      //
      BYTE s1[] = { 0x05, 0x02, 0x00, 0x02 };
      SendData( s1, 4 );
      char r1[ 2 ];
      WaitUntilRecv( 15000 );
      if( RecvData( (BYTE*)r1, 2 ) != 2 )
      { 
         /*AfxMessageBox( "BAD1!" );*/ 
         MYTRACE( "   ERROR: Proxy connection error 1\n" );
         goto shutshit; 
      }

      //BYTE s2[] = { 0x05, 0x01, 0x00, 0x01, 0xD8, 0x21, 0x2A, 0x4E, 0x0A, 0x02 }; // 5h, 1h, 0h, 1h,  216.33.42.78:2562
      //SendData( s2, 10 );
     
      om.Init( false );
      om.AddDword( 0x01000105 );
      om.AddDword( inet_addr( odigo_addr ) );
      om.AddRShort( odigo_port );
      om.GetMsgBuff( SendBuff, &len );
      SendData( SendBuff, len );

      char r2[ 10 ];
      WaitUntilRecv( 15000 );
      if( RecvData( (BYTE*)r2, 10 ) != 10 )
      { 
         /*AfxMessageBox( "BAD2!" );*/ 
         MYTRACE( "   ERROR: Proxy connection error 2\n" );
         goto shutshit; 
      }
   }else{
      //
      // connect without proxy
      //
      MYTRACE( "   Direct connect... (odigo: %s:%i)\n", odigo_addr, odigo_port );
      sa.sin_port = htons((unsigned short)odigo_port);
      sa.sin_family = AF_INET;
      sa.sin_addr.S_un.S_addr = inet_addr( odigo_addr );
      if( connect( sock, (sockaddr*)&sa, sizeof( sockaddr_in ) ) )
      {
         MYTRACE( "   ERROR: Unable to connect socket\n" );
         goto shutshit;
      }

      //InternalRead = true;
      WSAAsyncSelect( sock, hwnd, WM_USER + 123, FD_READ | FD_CLOSE );
   }
   InternalRead = false;

   MYTRACE( "   Connection successed...\n" );

   //0x03, 0x46, 0x42, 0x53, 0x00, 0x2D, 0x00, 0x04, 0x00, 0x00, 0x0A, 0x03, 0x01, 0x00, 0x00, 0x0E,          // .FBS.-..........
   //0x93, 0x00, 0x06, 0x67, 0x67, 0x74, 0x65, 0x73, 0x74, 0x09, 0x6F, 0x64, 0x69, 0x67, 0x6F, 0x2E,          // {..ggtest.odigo.
   //0x63, 0x6F, 0x6D, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x45, 0x4F, 0x48, 0x00, 0x03, 0x00, 0x01     // com.......EOH....
   MakeStdHeader( &om, 0x01030A00, false );
   om.AddDword( 0x01000300 );
   om.AddShortLenToPos( 0x06 );

   MYTRACE( "   Sending first packet (user: %s@%s, SID: %Xh)...\n", odigo_user_name, odigo_user_host, sessid );
   om.GetMsgBuff( SendBuff, &len );
   SendData( SendBuff, len );
   return true;
}



//-------------------------------------------------------------------------------------------
void COdigoConnection::ODC_Disconnect( void )
{
   MYTRACE( "> %s\n", __FUNCTION__ );
   FlushResponseStack();

   COdigoMessage   om;
   //buf: 0000  03 46 42 53 00 42 00 03-00 00 0E 03 01 00 00 73   .FBS.B.........s
   //     0010  AD 15 49 4D 32 30 31 36-30 33 36 39 32 34 34 30   ..IM201603692440
   //     0020  33 32 37 32 31 38 35 06-67 67 74 65 73 74 09 6F   3272185.ggtest.o
   //     0030  64 69 67 6F 2E 63 6F 6D-00 00 00 00 00 00 03 45   digo.com.......E
   //     0040  4F 48 00 03 00                                    OH...

   //BYTE s4[] = { 
   //0x03, 0x46, 0x42, 0x53, 0x00, 0x2D, 0x00, 0x04, 0x00, 0x00, 0x0A, 0x03, 0x01, 0x00, 0x00, 0x0E,          // .FBS.-..........
   //0x93, 0x00, 0x06, 0x67, 0x67, 0x74, 0x65, 0x73, 0x74, 0x09, 0x6F, 0x64, 0x69, 0x67, 0x6F, 0x2E,          // {..ggtest.odigo.
   //0x63, 0x6F, 0x6D, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x45, 0x4F, 0x48, 0x00, 0x03, 0x00, 0x01 };  // com.......EOH...
   MakeStdHeader( &om, 0x01030E00, false );
   om.AddByte( 0x00 );
   om.AddShort( 0x0003 );
   om.AddShortLenToPos( 0x06 );

   int len;
   om.GetMsgBuff( SendBuff, &len );
   SendData( SendBuff, len );

   ::KillTimer( m_Wnd, PONGTIMERID );
   ::KillTimer( m_Wnd, MSGPRESPTIMERID );
   ::KillTimer( m_Wnd, MSG_TIMEOUT_CHECK_TIMERID );

   shutdown( sock, 2 );
   closesocket( sock );
   ODC_OnSocketClose();
   
   MYTRACE( "[[[**** Session status ****]]]: recv(%lu times): %lu bytes, sent(%lu times): %lu bytes\n", 
            m_iRecvCount, m_iRecvTraff, m_iSendCount, m_iSendTraff );
   ResetAll();
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::FillFriends( COdigoMessage *om )
{
   MYTRACE( "> %s\n", __FUNCTION__ );
   ODC_OnBeginFriendsFill();

   om->Skip( 5 );// hdr
   BYTE bp = om->GetByte();
   //om->GetShort();
   //DWORD tp = om->GetDword();// tp = 0x03030B00
   om->ToPos( bp );

   //om->Dump2File( "d:\\ddd" );
   om->Skip( 0x3C - 6 );
   BYTE grpnum = om->GetByte();
   om->Skip( 5 );

   char name[ 300 ];
   char numb[ 300 ];
   char host[ 300 ];
   char groupname[ 300 ];

   for( BYTE gn = 0; gn < grpnum; gn++ )
   {
      om->GetBuffWL( (BYTE*)groupname, true );
      ODC_OnFriendsFillGroup( groupname );
      om->Skip( 2 );
      BYTE fn = om->GetByte();
      for( BYTE b = 0; b < fn; b++ )
      {
         om->Skip( 5 );
         om->GetBuffWL( (BYTE*)numb, true );
         om->GetBuffWL( (BYTE*)host, true );
         om->Skip( 3 );
         om->GetBuffWL( (BYTE*)name, true );
         om->Skip( 6 );
         ODC_OnFriendsFillUser( name, numb, host);
      }
      om->Skip( 5 );
   }
   ODC_OnEndFriendsFill();
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::UserStatus( COdigoMessage *om )
{
   MYTRACE( "> %s\n", __FUNCTION__ );
   om->Skip( 5 );// hdr
   BYTE bp = om->GetByte();
   //om->GetShort();
   //DWORD tp = om->GetDword();// tp = 0x0503C800
   om->ToPos( bp );
   om->Skip( 6 );
   BYTE stat = om->GetByte();
   char numb[ 300 ];
   char host[ 300 ];
   om->GetBuffWL( (BYTE*)numb, true );
   om->GetBuffWL( (BYTE*)host, true );
   int odstat = ODIGO_USER_STATUS_UNKNOWN;
   switch( stat )
   {
      case 0x22: odstat = ODIGO_USER_STATUS_OFFLINE; break;
      case 0x23: odstat = ODIGO_USER_STATUS_ONLINE; break;
      // TODO: fixit
      //case 0x: odstat = ODIGO_USER_STATUS_BUSY; break;
      //case 0x: odstat = ODIGO_USER_STATUS_BACKSOON; break;
      //case 0x: odstat = ODIGO_USER_STATUS_AWAY; break;
      //case 0x: odstat = ODIGO_USER_STATUS_ONMEET; break;
   }
   ODC_OnUserStatusChange( odstat, numb, host );
}


//-------------------------------------------------------------------------------------------
int COdigoConnection::ODC_SendPrivateMessage( char *msg_to_name, char *msg_to_host, char *html_text )
{
   MYTRACE( "> %s\n", __FUNCTION__ );

   //buf: 0000  03 46 42 53 00 43 00 BB-00 00 64 03 05 00 00 52   .FBS.C....d....R
   //     0010  8B 16 49 4D 2D 38 37 36-37 31 33 37 32 38 39 33   ..IM-87671372893
   //     0020  39 31 39 32 30 33 32 38-06 67 67 74 65 73 74 09   91920328.ggtest.
   //     0030  6F 64 69 67 6F 2E 63 6F-6D 00 00 00 00 00 00 03   odigo.com.......
   //     0040  45 4F 48 00 02 00 01 07-33 37 35 32 34 36 35 09   EOH.....3752465.
   //     0050  6F 64 69 67 6F 2E 63 6F-6D 00 1F 06 67 67 74 65   odigo.com...ggte
   //     0060  73 74 09 6F 64 69 67 6F-2E 63 6F 6D 01 06 67 67   st.odigo.com..gg
   //     0070  74 65 73 74 00 00 00 00-00 00 52 8B 01 00 03 00   test......R.....
   //     0080  00 14 32 30 30 33 2D 30-37 2D 31 39 54 32 32 3A   ..2003-07-19T22:
   //     0090  35 33 3A 34 34 5A 14 31-39 37 30 2D 30 31 2D 30   53:44Z.1970-01-0
   //     00A0  31 54 30 33 3A 30 30 3A-30 30 5A 00 4D 01 02 00   1T03:00:00Z.M...
   //     00B0  00 48 00 44 3C 48 54 4D-4C 3E 3C 42 4F 44 59 3E   .H.D<HTML><BODY>
   //     00C0  3C 46 4F 4E 54 20 46 41-43 45 3D 22 41 72 69 61   <FONT FACE="Aria
   //     00D0  6C 22 20 3E 50 52 49 56-41 54 45 20 4D 45 53 53   l" >PRIVATE MESS
   //     00E0  41 47 45 3C 2F 46 4F 4E-54 3E 3C 2F 42 4F 44 59   AGE</FONT></BODY
   //     00F0  3E 3C 2F 48 54 4D 4C 3E-00 00 00 00 00 00         ></HTML>......

   COdigoMessage   om, om1;

   char *msg2username = msg_to_name;
   char *msg2userhost = msg_to_host;
   char *odigo_user_nik = odigo_user_name;

   MakeStdHeader( &om, 0x05036400, true );

   om1.Init( false );
   om1.AddByte( 0x00 );
   om1.AddByte( 0x02 );
   om1.AddByte( 0x00 );
   om1.AddByte( 0x01 );
   om1.AddBuffWL( (BYTE*)msg2username, lstrlen( msg2username ), true );
   om1.AddBuffWL( (BYTE*)msg2userhost, lstrlen( msg2userhost ), true );
   om1.AddByte( 0x00 );
   om1.AddByte( 0x1F );
   om1.AddBuffWL( (BYTE*)odigo_user_name, lstrlen( odigo_user_name ), true );
   om1.AddBuffWL( (BYTE*)odigo_user_host, lstrlen( odigo_user_host ), true );
   om1.AddByte( 0x01 );
   om1.AddBuffWL( (BYTE*)odigo_user_nik, lstrlen( odigo_user_nik ), true );
   om1.AddRepeatedBytes( 0x00, 6 );
   om1.AddShort( recv_sessid );

   BYTE sb[] = { 0x01, 0x00, 0x03, 0x00,
      0x00, 0x14, 0x32, 0x30, 0x30, 0x33, 0x2D, 0x30, 0x37, 0x2D, 0x31, 0x39, 0x54, 0x32, 0x32, 0x3A,
      0x35, 0x33, 0x3A, 0x34, 0x34, 0x5A, 0x14, 0x31, 0x39, 0x37, 0x30, 0x2D, 0x30, 0x31, 0x2D, 0x30,
      0x31, 0x54, 0x30, 0x33, 0x3A, 0x30, 0x30, 0x3A, 0x30, 0x30, 0x5A
   };

   ZeroMemory( SendBuff, sizeof( SendBuff ) );
   UTIL_ConvertANSItoUTF8( html_text, (char*)SendBuff );

   om1.AddBuff( sb, sizeof( sb ), false );
   om1.AddRShort( lstrlen( (char*)SendBuff ) + 8 );// text
   om1.AddByte( 0x01 );
   om1.AddByte( 0x02 );
   om1.AddByte( 0x00 );
   om1.AddRShort( lstrlen( (char*)SendBuff ) + 4 );// text

   // convert
   om1.AddRShort( lstrlen( (char*)SendBuff ) );
   om1.AddBuff( SendBuff, lstrlen( (char*)SendBuff ), false );
   om1.AddRepeatedBytes( 0x00, 6 );

   // compress
   int dlen = om1.GetPos();
   om1.ToBegin();
   om1.GetBuff( TempBuff, dlen, false );
   zlb.Deflate_MemoryToMemory( TempBuff, dlen, TempBuff1, ODIGO_SENDBUFF_LEN );
   
   om.AddBuff( TempBuff1, zlb.Total_Out, false );
   om.AddShortLenToPos( 0x06 );
   //om.Dump2File( "d:\\dat_priv" );

   int len;
   om.GetMsgBuff( SendBuff, &len );
   SendData( SendBuff, len );

   PushMessageTimeout( recv_sessid );
   return recv_sessid;
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::FlushResponseStack( void )
{
   if( !m_iMsgResponseCount ) return;// none to flush
   MYTRACE( "> %s (stacklen = %lu)\n", __FUNCTION__, m_iMsgResponseCount );

   COdigoMessage omt;
   MakeStdHeader( &omt, 0x01031400, false );
   omt.AddByte( 0x00 );
   omt.AddByte( 0x03 );
   omt.AddRepeatedBytes( 0x00, 2 );
   omt.AddByte( m_iMsgResponseCount );
   for( int i = 0; i < m_iMsgResponseCount; i++ )
   {
      omt.AddShort( MsgResponseStack[ i ].conf );
      omt.AddShort( MsgResponseStack[ i ].id );
   }
   omt.AddRepeatedBytes( 0x00, 3 );
   omt.AddShortLenToPos( 0x06 );
   int len;
   omt.GetMsgBuff( SendBuff, &len );
   SendData( SendBuff, len );

   // shut users send from
   DWORD c_name[ MAX_ODIGO_MSGRESPONSE ];
   DWORD c_host[ MAX_ODIGO_MSGRESPONSE ];
   int c_i = 0;
   for( int i = 0; i < m_iMsgResponseCount; i++ )
   {
      if( !MsgResponseStack[ i ].isprivate ) continue;// do not reply to non private messages
      bool exist = false;
      DWORD cn = UTIL_Adler32( 665, MsgResponseStack[ i ].from_name, lstrlen( MsgResponseStack[ i ].from_name ) );
      DWORD ch = UTIL_Adler32( 665, MsgResponseStack[ i ].from_host, lstrlen( MsgResponseStack[ i ].from_host ) );
      for( int i1 = 0; i1 < c_i; i1++ )
         if( c_name[ i1 ] == cn && c_host[ i1 ] == ch )
         {
            exist = true;
            break;
         }
      if( exist ) continue;
      
      c_name[ c_i ] = cn;
      c_host[ c_i ] = ch;
      c_i++;
      
      // send msg
      MakeStdHeader( &omt, 0x01033500, false );
      omt.AddByte( 0x00 );
      omt.AddByte( 0x03 );
      omt.AddByte( 0x00 );
      omt.AddBuffWL( (BYTE*)MsgResponseStack[ i ].from_name, lstrlen( MsgResponseStack[ i ].from_name ), true );
      omt.AddBuffWL( (BYTE*)MsgResponseStack[ i ].from_host, lstrlen( MsgResponseStack[ i ].from_host ), true );
      omt.AddShortLenToPos( 0x06 );
      int len;
      omt.GetMsgBuff( SendBuff, &len );
      SendData( SendBuff, len );
   }

   m_iMsgResponseCount = 0;
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::PushMessageTimeout( int recv_sessid, int timeout )
{
   MYTRACE( "> %s ( %Xh, time: %i )\n", __FUNCTION__, recv_sessid, timeout );
   for( int i = 0; i < MAX_ODIGO_MSG_TIMEOUTBUFF; i++ )
      if( MsgsTimeCheckStack[ i ].id == 0 )
      {
         MsgsTimeCheckStack[ i ].id = recv_sessid;
         MsgsTimeCheckStack[ i ].timeout_tick = GetTickCount() + timeout;
         return;
      }
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::FreeMessageTimeout( int recv_sessid )
{
   for( int i = 0; i < MAX_ODIGO_MSG_TIMEOUTBUFF; i++ )
      if( MsgsTimeCheckStack[ i ].id == recv_sessid )
      {
         MsgsTimeCheckStack[ i ].id = 0;
         return;
      }
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::CheckMessagesTimeout( void )
{
   DWORD tick = GetTickCount();
   for( int i = 0; i < MAX_ODIGO_MSG_TIMEOUTBUFF; i++ )
      if( MsgsTimeCheckStack[ i ].id != 0 && tick > MsgsTimeCheckStack[ i ].timeout_tick )
      {
         MYTRACE( "> Message with id: %Xh, has timeout\n", MsgsTimeCheckStack[ i ].id );
         ODC_OnMessageTimeout( MsgsTimeCheckStack[ i ].id );
         MsgsTimeCheckStack[ i ].id = 0;// free
      }
}


//-------------------------------------------------------------------------------------------
void COdigoConnection::MsgConfirm( COdigoMessage *om )
{
   om->Skip( 5 );// hdr
   BYTE bp = om->GetByte();
   om->ToPos( bp );
   om->Skip( 4 );
   USHORT conf = om->GetShort();
   //MYTRACE( "  > conf: %Xh\n", conf );
   FreeMessageTimeout( conf );
   ODC_OnMessageConfirm( conf );
   MYTRACE( "> %s (%Xh)\n", __FUNCTION__, conf );
}


