// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently,
// but are changed infrequently

#pragma once

#ifndef VC_EXTRALEAN
#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers
#endif

// Modify the following defines if you have to target a platform prior to the ones specified below.
// Refer to MSDN for the latest info on corresponding values for different platforms.
#ifndef WINVER				// Allow use of features specific to Windows 95 and Windows NT 4 or later.
#define WINVER 0x0400		// Change this to the appropriate value to target Windows 98 and Windows 2000 or later.
#endif

#ifndef _WIN32_WINNT		// Allow use of features specific to Windows NT 4 or later.
#define _WIN32_WINNT 0x0400		// Change this to the appropriate value to target Windows 98 and Windows 2000 or later.
#endif						

#ifndef _WIN32_WINDOWS		// Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
#endif

#ifndef _WIN32_IE			// Allow use of features specific to IE 4.0 or later.
#define _WIN32_IE 0x0400	// Change this to the appropriate value to target IE 5.0 or later.
#endif

#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS	// some CString constructors will be explicit

// turns off MFC's hiding of some common and often safely ignored warning messages
#define _AFX_ALL_WARNINGS

#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions

#include <afxdtctl.h>		// MFC support for Internet Explorer 4 Common Controls
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h>			// MFC support for Windows Common Controls
#endif // _AFX_NO_AFXCMN_SUPPORT

#include <afxsock.h>		// MFC socket extensions


void MYTRACEF( const char *fmt, ... );// Fast
void MYTRACE( const char *fmt, ... );// With Flush
void _MYTRACE( const char *fmt, ... );// With Flush without date


//--------------------------------------------------------------------------------------------
// TODO: move to good location, add more ctrls
static char GET_CTRL_SZ_ERROR[ 300 ];
#define GET_DLG_CTRL(dlg,nam,id) (nam*)dlg->GetDlgItem( id ) == NULL ? \
   wsprintf( GET_CTRL_SZ_ERROR, "GET_CTRL Failed! (Control %s with id %s)\nSource File: %hs\nLine: %d\n\nThat should never happen lucky boy :)\nContact with author with error description", #nam, #id, __FILE__, __LINE__ ) , \
   ::MessageBox( ::GetFocus(), GET_CTRL_SZ_ERROR, "Error in Dialog Source", MB_ICONERROR ) : \
   ((nam*)dlg->GetDlgItem( id ))

#define VAR_CTRL(var,nam,id) nam *var = (nam*)GetDlgItem( id ); \
   if( var == NULL ) \
   { \
      wsprintf( GET_CTRL_SZ_ERROR, "VAR_CTRL Failed! (Control %s with id %s)\nSource File: %hs\nLine: %d\n\nThat should never happen lucky boy :)\nContact with author with error description", #nam, #id, __FILE__, __LINE__ ); \
      ::MessageBox( ::GetFocus(), GET_CTRL_SZ_ERROR, "Error in Dialog Source", MB_ICONERROR ); \
   }

#define GET_DLG_BUTTON(dlg,id)    GET_DLG_CTRL(dlg,CButton,id)
#define GET_DLG_EDIT(dlg,id)      GET_DLG_CTRL(dlg,CEdit,id)
#define GET_DLG_STATIC(dlg,id)    GET_DLG_CTRL(dlg,CStatic,id)
#define GET_DLG_PBAR(dlg,id)      GET_DLG_CTRL(dlg,CProgressCtrl,id)
#define GET_DLG_LIST(dlg,id)      GET_DLG_CTRL(dlg,CListBox,id)
#define GET_DLG_DATETIME(dlg,id)  GET_DLG_CTRL(dlg,CDateTimeCtrl,id)
#define GET_DLG_COMBO(dlg,id)     GET_DLG_CTRL(dlg,CComboBox,id)
#define GET_DLG_IPADDRESS(dlg,id) GET_DLG_CTRL(dlg,CIPAddressCtrl,id)
#define GET_DLG_LISTCTRL(dlg,id)  GET_DLG_CTRL(dlg,CListCtrl,id)

#define GET_BUTTON(id)    GET_DLG_BUTTON(this,id)
#define GET_EDIT(id)      GET_DLG_EDIT(this,id)
#define GET_STATIC(id)    GET_DLG_STATIC(this,id)
#define GET_PBAR(id)      GET_DLG_PBAR(this,id)
#define GET_LIST(id)      GET_DLG_LIST(this,id)
#define GET_DATETIME(id)  GET_DLG_DATETIME(this,id)
#define GET_COMBO(id)     GET_DLG_COMBO(this,id)
#define GET_IPADDRESS(id) GET_DLG_IPADDRESS(this,id)
#define GET_LISTCTRL(id)  GET_DLG_LISTCTRL(this,id)


//-------------------------------------------------------------------------------------------
void DumpMemory( char *name, void *mem, ULONG size );
int OpenDialog( HWND hw, char *filename, char *title, char *defpath, char *defext, char *filter );
int SaveDialog( HWND hw, char *filename, char *title, char *defpath, char *defext, char *filter );
void InitiateLogFile( char *logfilename );
char *NET_ErrorString( void );
void SkinPlaySound( char *szSndVar );
LONG RANDOM_LONG( LONG min, LONG max );
float RANDOM_FLOAT( float min, float max );
ULONG UTIL_Adler32( ULONG adler, CHAR *buf, UINT len );
void UTIL_ConvertUTF8toANSI( char *utf8, char *outstr );
void UTIL_ConvertANSItoUTF8( char *string, char *utf8 );
void BuildRightFileName( char *Source, char *Dest );


//-------------------------------------------------------------------------------------------
#include "Winsock2.h"
